import { ElementStyle } from "./ElementStyle";
export declare class Joystick {
    private isMousePressed;
    private touchId;
    private transformProperty;
    private isTransform3dSupported;
    container: HTMLElement;
    style: {
        stick?: ElementStyle;
        base?: ElementStyle;
    };
    stickElement: HTMLElement;
    baseElement: HTMLElement;
    isMouseSupporting: boolean;
    isStationaryBase: boolean;
    isVisible: boolean;
    stickX: number;
    stickY: number;
    baseX: number;
    baseY: number;
    isStickLimited: boolean;
    stickLimitRadius: number;
    isPreferringCssTransform: boolean;
    elementsContainer: HTMLElement;
    onDeltaChanged: (joystick: Joystick) => void;
    onDown: (joystick: Joystick) => void;
    onUp: (joystick: Joystick) => void;
    constructor(options: Partial<Joystick>);
    destroy(): void;
    recalculatePosition(): void;
    getDeltaX(): number;
    getDeltaY(): number;
    private getBaseElementCenterX();
    private getBaseElementCenterY();
    private getStickCenterX();
    private getStickCenterY();
    private returnStickToBase();
    private buildStickElement();
    private buildBaseElement();
    private initializeElements();
    private initBaseStyle();
    private initStickStyle();
    private bindListeners();
    private onTouchStart;
    private onTouchEnd;
    private onTouchMove;
    private onMouseDown;
    private onMouseUp;
    private onMouseMove;
    private up();
    private down(x, y);
    private move(x, y);
    private moveStick(x, y);
    private moveElement(style, x, y);
}
